/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the BillingItemsList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &BillingItemsList{}

// BillingItemsList struct for BillingItemsList
type BillingItemsList struct {
	Results []BillingItem `json:"results"`
	Total int32 `json:"total"`
}

// NewBillingItemsList instantiates a new BillingItemsList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewBillingItemsList(results []BillingItem, total int32) *BillingItemsList {
	this := BillingItemsList{}
	this.Results = results
	this.Total = total
	return &this
}

// NewBillingItemsListWithDefaults instantiates a new BillingItemsList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewBillingItemsListWithDefaults() *BillingItemsList {
	this := BillingItemsList{}
	return &this
}

// GetResults returns the Results field value
func (o *BillingItemsList) GetResults() []BillingItem {
	if o == nil {
		var ret []BillingItem
		return ret
	}

	return o.Results
}

// GetResultsOk returns a tuple with the Results field value
// and a boolean to check if the value has been set.
func (o *BillingItemsList) GetResultsOk() ([]BillingItem, bool) {
	if o == nil {
		return nil, false
	}
	return o.Results, true
}

// SetResults sets field value
func (o *BillingItemsList) SetResults(v []BillingItem) {
	o.Results = v
}

// GetTotal returns the Total field value
func (o *BillingItemsList) GetTotal() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Total
}

// GetTotalOk returns a tuple with the Total field value
// and a boolean to check if the value has been set.
func (o *BillingItemsList) GetTotalOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Total, true
}

// SetTotal sets field value
func (o *BillingItemsList) SetTotal(v int32) {
	o.Total = v
}

func (o BillingItemsList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o BillingItemsList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["results"] = o.Results
	toSerialize["total"] = o.Total
	return toSerialize, nil
}

type NullableBillingItemsList struct {
	value *BillingItemsList
	isSet bool
}

func (v NullableBillingItemsList) Get() *BillingItemsList {
	return v.value
}

func (v *NullableBillingItemsList) Set(val *BillingItemsList) {
	v.value = val
	v.isSet = true
}

func (v NullableBillingItemsList) IsSet() bool {
	return v.isSet
}

func (v *NullableBillingItemsList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableBillingItemsList(val *BillingItemsList) *NullableBillingItemsList {
	return &NullableBillingItemsList{value: val, isSet: true}
}

func (v NullableBillingItemsList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableBillingItemsList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


